#include <allegro.h>
//#include <jgmod.h>
#include "common.h"
#include "gamedata.h"
#include "game.h"
#include "data.h"
#include "c4.h"
#include "dirty.h"

#define INPUTMOVE 1
#define DROPPIECE 2
#define JUSTLOOP 3
#define EXITLOOP 4

void setmousepointer();
void declarewinner();
void process();
void initgame();
void displayboard();
void screenoutput(int x, int y);
void waitkey();
int moveinput();
int findemptyrow(int i);
void controlinput();
void preparebmp(RLE_SPRITE *bmp);
void winningline();
void waitforexit();
void initdroppiece (int col);
void movedroppiece ();
void checkfour();

void markemptyrows();
void findcpumove(); // ugly function to locate and undo cpu move;
int emptyrows[BOARD_W]; // holds empty rows to undo and then redo cpu move,
			// in order to slide the piece down
int gamemode; // either INPUTMOVE or DROPPIECE
int levels[4]; // starting from 1, contains the cpu level passed to c4_auto_move
int keybact; //  if keyboard input has been activated, holds the col number
int userabort;
int plcolors[2]; // player colors
int gameover;
int mousecursor; // shape of mouse pointer
int winner;
int cols[BOARD_W];	// where each board column starts, in
			//pixels, gets value in displayboard();
char msgtext[100];
int msgcol;
char *plid[4];
int mousevisible;
int mousx, mousy;
int suggested=0;


RLE_SPRITE *back; // rem holds the background


struct CLICKABLE {
	int x, y;
	int cx, cy; // coords for collision
	int cw,ch; // coords for collision
	int col[2];
	int status;
	char s[20];
	char hint[20];
	int delay; // to prevent repeated activation
} button[2];

struct PEG {
	int status;
	int x,y;
	int desty;
	int dy;
	int count; // for various purposes
} peg,arrow,droppiece,lastpeg;

void initdroppiece(int col)
{
    droppiece.x=cols[col]+11;
    droppiece.desty=300-(emptyrows[col]*49);
    droppiece.y=0;
    droppiece.dy=6;
    droppiece.status=1;
    droppiece.count=0;
}

void movedroppiece ()
{
    droppiece.y+=droppiece.dy;
    droppiece.count++;
    if (droppiece.count>2) {
	droppiece.count=0;
	droppiece.dy++;
    }
    if (droppiece.y>droppiece.desty) {
	play_sample(data[_fall].dat,240,0,1000,0);
	if (bouncy) {
	  droppiece.y=droppiece.desty;
	  droppiece.dy=-(droppiece.dy/4);
	  if (droppiece.dy==0) {
	      droppiece.status=0;
	  }
	} else droppiece.status=0;
    }
    if (slide==0) {
	droppiece.status=0;
	if (!nosound) play_sample(data[_fall].dat,240,0,1000,0);
    }
}

void checkfour()
{
    if (c4_is_winner(1)) winner=1;
    if (c4_is_winner(0)) winner=0;
    gameover=(c4_is_winner(0)) || (c4_is_winner(1)) || (c4_is_tie());
    if ((gameover) && (gamemode==INPUTMOVE)) gamemode=JUSTLOOP;

}

void markemptyrows()
{
    int i;
    for (i=0; i<BOARD_W; i++) {
	emptyrows[i]=findemptyrow(i);
    }
}

void findcpumove(int *movex, int *movey)
{
    int i;
    for (i=0; i<BOARD_W; i++) {
	if (emptyrows[i]!=findemptyrow(i)) {
	    *movex=i;
	}
    }
    *movey=emptyrows[*movex];
}

void initgame()
{
	//initparticles();
	gamemode=INPUTMOVE;
	target_game_time=0;
	mousx=0;
	mousy=0;
	//bouncy=0;
	mousevisible=1;
	lastpeg.status=0;
	//back=create_bitmap(SCRW,SCRH);
	levels[1]=2;
	levels[2]=5;
	levels[3]=8;
	gameover=0;
	keybact=-1;
	button[0].x=16;
	button[0].y=460;
	sprintf(button[0].s,"EXIT!");
	sprintf(button[0].hint," ");
	button[0].cx=button[0].x-4;
	button[0].cy=button[0].y-10;
	button[0].cw=text_length(font,"EXIT!")+8;
	button[0].ch=28;
	button[0].status=0;
	button[0].delay=0;
	button[0].col[0]=makecol(200,200,200);
	button[0].col[1]=makecol(255,255,255);
	button[1].x=581;
	button[1].y=460;
	sprintf(button[1].s,"Reset");
	sprintf(button[1].hint," ");
	button[1].cx=button[1].x-4;
	button[1].cy=button[1].y-10;
	button[1].cw=text_length(font,"Reset")+8;
	button[1].ch=28;
	button[1].status=0;
	button[1].delay=0;
	button[1].col[0]=makecol(200,200,200);
	button[1].col[1]=makecol(255,255,255);
	winner=-1;
	userabort=0;
	mousecursor=_pointer;
	plcolors[0]=makecol(200,0,0);
	plcolors[1]=makecol(200,200,0);
	plid[0]="human brain";
	plid[1]="10mhz cpu";
	plid[2]="200mhz cpu";
	plid[3]="2ghz cpu";
	arrow.status=0;
	turn=firsttoplay;
	sprintf(msgtext,"/0");
	msgcol=makecol(0,0,0);
	c4_new_game(BOARD_W, BOARD_H, 4); // width, height, num to connect
	board=c4_board(); // init local board
	clear_keybuf();
	preparebmp(back);
}

void declarewinner()
{
    if (userabort==0) {
	if (winner==0) {
		sprintf(msgtext,"Red Player Won!");
		msgcol=makecol(255,0,0);
	} else if (winner==1) {
		sprintf(msgtext,"Yellow Player Won!");
		msgcol=makecol(255,255,0);
	} else {
		sprintf(msgtext,"It's a tie!");
		msgcol=makecol(255,255,255);
	}
    } else if (userabort==1) {
	sprintf(msgtext,"Game Aborted!");
	msgcol=makecol(0,255,255);
    }
}

int playgame()
{
	int actual_game_time = 0, ok_to_draw = TRUE;
	initgame();
	LOCK_VARIABLE(target_game_time);
	LOCK_FUNCTION(increment_target_game_time);
	install_int_ex(increment_target_game_time, BPS_TO_TIMER(30));
	do {
	    while(actual_game_time < target_game_time) {
		actual_game_time++;
		ok_to_draw = TRUE;
		process();
	    }

	    if(ok_to_draw) {
		screenoutput(RESX,RESY);
		if (osfriendly) yield_timeslice();
		ok_to_draw = FALSE;
	    }
	} while (gamemode!=EXITLOOP);

	//(((gameover==0) && (userabort==0)) || (gamemode==DROPPIECE));
	remove_int(increment_target_game_time);
	//if (userabort!=2) waitforexit();
	mousevisible=0;
	c4_end_game();
	destroy_rle_sprite(back);
	if (userabort==2) return(2);
	return(0);
}

void setmousepointer()
{
    int tmp;
    mousx=mouse_x;
    mousy=mouse_y;
    tmp=detectcollision(cols[0],1,(cols[BOARD_W-1]+49)-cols[0],380,mousx,mousy,1,1);
    if (turn==0) mousecursor=_redpeg;
       else mousecursor=_yellowpeg;
    if ((!tmp) || (pls[turn]!=0) || (gamemode==JUSTLOOP) || (gamemode==DROPPIECE)) {
	    mousecursor=_pointer; // set mouse pointer
	    arrow.status=0;
    }
}

void process()
{
    static int mademove;
    if (turn==0) {
	    sprintf(msgtext,"Red Player is Playing...");
	    msgcol=makecol(200,0,0);
    }
    else {
	    sprintf(msgtext,"Yellow Player is Playing...");
	    msgcol=makecol(240,240,0);
    }
    setmousepointer();
    controlinput();
	if (gamemode==DROPPIECE) {
	    movedroppiece();
	    if (droppiece.status==0) {
		gamemode=INPUTMOVE;
		lastpeg.status=1;
		if (pls[turn]==0) {
		    lastpeg.x=mademove;
		    lastpeg.y=findemptyrow(mademove);
		    c4_make_move(turn, mademove , NULL);
		}
		turn=1-turn;
		mousevisible=1;
	    }
	}
	checkfour();
	if (gamemode==INPUTMOVE) {
	    if (pls[turn]==0) { //if player is human
		mademove=moveinput(turn);
		if (mademove!=-1) {
		   if (!nosound) play_sample(data[_cmd].dat,128,0,500,0);
		   //mousevisible=0;
		   mousecursor=_pointer; // set mouse pointer
		   arrow.status=0;
		   markemptyrows();
		   gamemode=DROPPIECE;
		   initdroppiece(mademove);
		}
	    } else
	    if (pls[turn]>0) { //if player is computer
		markemptyrows();
		c4_auto_move(turn, levels[pls[turn]], NULL, NULL);
		findcpumove(&lastpeg.x,&lastpeg.y);
		mademove=lastpeg.x;
		//mousevisible=0;
		mousecursor=_pointer; // set mouse pointer
		arrow.status=0;
		gamemode=DROPPIECE;
		initdroppiece(mademove);
		//play_sample(data[_cmd].dat,128,0,3000,0);
	    }
	}
}

void waitforexit()
{
	do {

	} while (CMDKEY);
	do {

	} while ((!CMDKEY) && (!key[KEY_ESC]));
	if (button[1].status==1) userabort=2;
}

void waitkey()
{
	clear_keybuf();
	do {
	} while (keypressed() || (mouse_b & 1));
	do {
	} while (!keypressed() && (!mouse_b & 1));
}



void controlinput()
{
	int tmp,i;
	static int pressed;
	//static int px,py; // previous mouse coords
	for (i=0; i<2; i++) {
		if (button[i].delay>0) button[i].delay--;
		tmp=detectcollision(button[i].cx,button[i].cy,button[i].cw,button[i].ch,mousx,mousy,1,1);
		if ( (tmp) && (button[i].status==0) ) {
			button[i].status=1;
			if (!nosound) play_sample(data[_cmd].dat,128,0,1000,0);
		} else if ((!tmp) && (button[i].status==1)) button[i].status=0;
	}
	if ((button[0].status==1) && (CMDKEY)) {
	    userabort=1; // press exit button
	    gamemode=EXITLOOP;
	}
	if ((button[1].status==1) && (CMDKEY)) {
	    userabort=2; // press reset button
	    gamemode=EXITLOOP;
	}
	//if ((px!=mousx) || (py!=mousy)) createparticle(mousx,mousy);
	//px=mousx;
	//py=mousy;
	//processparticles();
	if (key[KEY_ESC]) {
	    userabort=1;
	    gamemode=EXITLOOP;
	}
	tmp=detectcollision(cols[0],1,(cols[BOARD_W-1]+49)-cols[0],380,mousx,mousy,1,1);
	if ((mousy !=10 ) || (!tmp)) keybact=-1;
	if ( ( (key[KEY_LEFT]) || (key[KEY_RIGHT]))  && (keybact==-1) ) {
		position_mouse(cols[0]+9,10);
		keybact=0;
		pressed=1;
	}
	if ((key[KEY_LEFT]) && (keybact>0) && (pressed==0)) {
		keybact--;
		position_mouse(cols[keybact]+9,10);
		pressed=1;
	}
	if ((key[KEY_RIGHT]) && (keybact<BOARD_W-1) && (pressed==0)) {
	keybact++;
	position_mouse(cols[keybact]+9,10);
	pressed=1;
	}
	if (!(key[KEY_LEFT] || key[KEY_RIGHT]) || (CMDKEY)) pressed=0;
	if (key[KEY_F10]) screencapture();
}


int moveinput()
{
	int i,tmp;
	static int pressed; // 1 if cmdkey is held down
	if (!CMDKEY) pressed=0;
	tmp=-1;
	for (i=0; i<BOARD_W; i++) {
		if (detectcollision (cols[i],1,49,380,mousx,mousy,1,1) && (board[i][BOARD_H-1]==C4_NONE)) {
			if (CMDKEY && !pressed) {
			    tmp=i;
			    pressed=1;
			}
			if (arrow.status==0) {
				arrow.status=1;
				arrow.x=cols[i]+4;
				arrow.y=-10;
				arrow.desty=300-(findemptyrow(i)*49);
				arrow.dy=4;
			}
			if ((arrow.status==1) && (arrow.x!=cols[i]+2)) {
				arrow.status=1;
				arrow.x=cols[i]+4;
				arrow.y=-10;
				arrow.desty=300-(findemptyrow(i)*49);
				arrow.dy=4;
			}
		}
	}
	if (keybact!=-1) arrow.status=0;
	return(tmp);
}

int findemptyrow(int c)
{
	int row=0;
	while ((board[c][row]!=C4_NONE) && (row<BOARD_H)) {
		row++;
	}
	return(row);
}

void displayboard()
{
	int i,n,offx,offy;
	board=c4_board();
	offx=100;
	offy=45;
	//draw_sprite(buffer,data[_boardback].dat,offx,offy);
	for (i=0; i<BOARD_W; i++) {
		cols[i]=offx+i*49+49-5;
		for (n=0; n<BOARD_H; n++) {
		    if ((gamemode==INPUTMOVE) || (lastpeg.x!=i) || (lastpeg.y!=n) || (turn!=board[i][n])) {
		    // do not display the peg if the drop anim hasn't stopped
			if (board[i][n]==0) {
				draw_sprite(buffer,data[_redpeg].dat,cols[i]+11,353-(8+offy+n*49));
			}
			if (board[i][n]==1) {
				draw_sprite(buffer,data[_yellowpeg].dat,cols[i]+11,353-(8+offy+n*49));
			}
		    }
		}
	}
	if (gamemode==JUSTLOOP) declarewinner();
	if ((lastpeg.status==1) && (gamemode==INPUTMOVE)) {
	    circle (buffer,cols[lastpeg.x]+28,369-(8+offy+lastpeg.y*49),1,makecol(110,120,100));
	    circle (buffer,cols[lastpeg.x]+28,369-(8+offy+lastpeg.y*49),2,makecol(150,160,140));
	}
	if ((arrow.status==1) && (gamemode==INPUTMOVE))  {
	    if (turn==0) {
		draw_sprite(buffer,data[_redarrow].dat,arrow.x,arrow.y);
	    }
	    else {
		 draw_sprite(buffer,data[_yellowarrow].dat,arrow.x,arrow.y);
	    }
	}
	if (gamemode==DROPPIECE) {
	    if (turn==0) {
		draw_sprite(buffer,data[_redpeg].dat,droppiece.x,droppiece.y);
	    }
	    if (turn==1) {
		draw_sprite(buffer,data[_yellowpeg].dat,droppiece.x,droppiece.y);
	    }
	}

	//draw_sprite(buffer,data[_redpeg].dat,cols[i]+9,353-(8+offy+n*49));
	//for (i=0; i<BOARD_W; i++) {
	//	rect(buffer,cols[i],10,cols[i]+49,400,makecol(255,255,255));
	//}
	if (drawfront) draw_sprite(buffer,data[_boardfront].dat,offx+46,offy);
	//textprintf(buffer,font,10,30,makecol(255,255,255),"button 0 status = %d",button[0].status);
	//textprintf(buffer,font,10,20,makecol(255,255,255),"mouse in board = %d",detectcollision(cols[0],1,(cols[BOARD_W-1]+49)-cols[0],380,mouse_x,mouse_y,1,1));
}

void screenoutput(resx,resy)
{
	int i;
	draw_rle_sprite(buffer,back,0,0);
	displayboard();
	for (i=0; i<2; i++) {
		outlinetext(buffer,font,button[i].s,button[i].x,button[i].y,button[i].col[button[i].status],makecol(0,0,0));
		if (button[i].status==1) {
			outlinetext(buffer,font,button[i].hint,mousx-110,mouse_y-10,makecol(0,0,0),makecol(255,255,255));
		}
	}
	outlinetext(buffer,font,msgtext,(SCRW-text_length(font,msgtext))/2,460,msgcol,makecol(0,0,0));
	//draw_sprite(buffer,data[_ico1].dat,musicbutton.x,musicbutton.y);
	if ((winner==0) || (winner==1)) winningline(); // draw winning line
	//if (mousecursor==_pointer) displayparticles();
	//if (mousevisible==1) {
	//    draw_sprite(buffer,data[mousecursor].dat,mousx,mousy);
	//    markdirtyrects(mousx-10,mousy-10,60,60);
	//}
	//textprintf(buffer,font,0,0,makecol(255,255,255),"lastpeg x, y=%d , %d",lastpeg.x,lastpeg.y);
	//textprintf(buffer,font,0,10,makecol(255,255,255),"gamemode=%d",gamemode);
	//textout(buffer,font,"160",160,0,makecol(255,255,255));
	//textout(buffer,font,"320",320,0,makecol(255,255,255));
	//textout(buffer,font,"480",480,0,makecol(255,255,255));
	//textout(buffer,font,"160",0,160,makecol(255,255,255));
	//textout(buffer,font,"320",0,320,makecol(255,255,255));
	//vsync();
	if (mousevisible) draw_sprite(buffer,data[mousecursor].dat,mousx,mousy);
	if (resx==640) masked_blit(buffer,screen,0,0,0,0,SCRW,SCRH);
	else stretch_blit(buffer,screen,0,0,SCRW,SCRH,0,0,resx,resy);
	clear(buffer);
}

void preparebmp(RLE_SPRITE *bmp)
{
	int tmp,tmp1;
	int offx,offy;
	//BITMAP *tempbmp;
	offx=104;
	offy=45;
	//set_trans_blender(255,0,0,0);
	if (pls[0]==0) {
	    draw_sprite_h_flip(buffer,data[_head].dat,-120,0);
	    //draw_lit_sprite(buffer,data[_head].dat,0,0,64);
	}
	else {
		draw_sprite_h_flip(buffer,data[_pc].dat,-120,0);
		//draw_lit_sprite(buffer,data[_pc].dat,0,0,64);
	}
	//set_trans_blender(255,255,0,0);
	if (pls[1]==0) {
		//tempbmp=create_bitmap(209,400);
		//blit(data[_head].dat,tempbmp,0,0,0,0,tempbmp->w,tempbmp->h);
		//draw_lit_sprite(tempbmp,data[_head].dat,0,0,32);
		draw_sprite(buffer,data[_head].dat,SCRW-326+120,0);
	}
	else {
		//tempbmp=create_bitmap(207,382); //207,382
		//blit(data[_pc].dat,tempbmp,0,0,0,0,tempbmp->w,tempbmp->h);
		//draw_lit_sprite(tempbmp,data[_pc].dat,0,0,32);
		draw_sprite(buffer,data[_pc].dat,SCRW-326+120,0);
	}
	//destroy_bitmap(tempbmp);
	blit(data[_gamepanel].dat,buffer,0,0,4,SCRH-100,640,100);
	tmp=((SCRW/2)-text_length(data[_aafont].dat,plid[pls[0]]))/2;
	tmp1=((SCRW/2)-text_length(data[_aafont].dat,plid[pls[1]]))/2;
	outlinetext(buffer,data[_aafont].dat,plid[pls[0]],tmp,400,makecol(220,0,0),makecol(0,0,0));
	//textout(buffer,data[_aafont].dat,plid[pls[0]],tmp,400,makecol(0,0,0));
	//textout(buffer,data[_aafont].dat,plid[pls[0]],tmp-4,396,makecol(220,0,0));
	outlinetext(buffer,data[_aafont].dat,plid[pls[1]],(SCRW/2)+tmp1,400,makecol(220,220,0),makecol(0,0,0));
	//textout(buffer,data[_aafont].dat,plid[pls[1]],tmp,400,makecol(0,0,0));
	draw_sprite(buffer,data[_boardback].dat,offx,offy);
	back=get_rle_sprite(buffer);
}

void winningline()
{
	int x[4],y[4],i;
	c4_win_coords(&x[0],&y[0],&x[3],&y[3]);
	if (x[3]-x[0]==3) {
		x[1]=x[0]+1;
		x[2]=x[1]+1;
	} else if (x[3]-x[0]==-3) {
		x[1]=x[0]-1;
		x[2]=x[1]-1;
	} else {
		x[1]=x[0];
		x[2]=x[0];
	}
	if (y[3]-y[0]==3) {
		y[1]=y[0]+1;
		y[2]=y[1]+1;
	} else if (y[3]-y[0]==-3) {
		y[1]=y[0]-1;
		y[2]=y[1]-1;
	} else	{
		y[1]=y[0];
		y[2]=y[0];
	}
	for (i=0; i<4; i++) {
		//circle (buffer,cols[x[i]]+24,316-(49*y[i]),8,makecol(30,30,30));
		circle (buffer,cols[x[i]]+27,369-(53+y[i]*49),8,makecol(30,31,32));
		//textprintf(screen,font,20,10+i*10,makecol(100,200,200),"win x y = %d %d",x[i],y[i]);
	}
}
