#include <allegro.h>
//#include <jgmod.h>
#include "common.h"
#include "gamedata.h"
#include "menu.h"
#include "data.h"

int mnuchoice; // rem active menu line
char *mnutxt[13];
int menuover;
static char firstinit;
struct SCROLLY {
	int x;
	int y;
	int delay;
	char s[1000]; // message to display
	char wr[81]; // the part of the message that fits on screen
	int ln; // message length
	int w; // how many letters fit on screen width
	int pos;
	//BITMAP *bmp;
} scrolly;



struct MENUITEM {
	int x,y,w,h,curcol,col1,col2;
	int mouseon; // when mouse pointer is on item
	char first; // points to the first text array
	char opts; // how many options this item has
	char curopt; // current option
} menuitem[6];

int menu()
{
	int actual_game_time = 0, ok_to_draw = TRUE;
	target_game_time=0;
	initmenu();
	position_mouse(100,100);
	clear(screen);
	clear_keybuf();
	processmenu(); // display screen for the first time
	displaymenu(RESX,RESY); // display screen for the first time
	LOCK_VARIABLE(target_game_time);
	LOCK_FUNCTION(increment_target_game_time);
	install_int_ex(increment_target_game_time, BPS_TO_TIMER(30));
	do {
		while(actual_game_time < target_game_time) {
			actual_game_time++;
			input();
			processmenu();
			ok_to_draw = TRUE;
			//createparticle(mouse_x,mouse_y);
			//processparticles();
		}
		if(ok_to_draw) {
			displaymenu(RESX,RESY);
			ok_to_draw = FALSE;
		}
	} while (menuover==0);
	remove_int(increment_target_game_time);
	pls[0]=menuitem[0].curopt;
	pls[1]=menuitem[1].curopt;
	firsttoplay=menuitem[2].curopt;
	if (firsttoplay==2) firsttoplay=rand()%2;
	clear(buffer);
	clear(screen);
	//destroy_bitmap(scrolly.bmp);
	return(menuover);
}

void initmenu()
{
	int i;
	text_mode(-1);
	menuover=0;
//	   sprintf(scrolly.s,"										      .... Welcome to 'tessera' (v1.0). This not terribly original game has been created by Spyros Paraschis, using the Allegro and JGMod libraries, created by Shawn Hargreaves and Jeffery Guan Foo Wah respectively. 'Tessera' wouldn't have been possible, without the great connect-n algorithm, created and kindly offered to the public domain by Keith Pomakis. The music you are hearing, providing this Amiga-feeling, is a remix of the Great Gianna Sisters theme, made by Chris Huelspeck, as far as I can tell looking at the XM file instruments. Enjoy the game and try to beat it at the higher level. The playing algorithm can play even better, but the '2GHz cpu' is already quite a challenge for me. Oh, by the way, 'tessera' means 'four' in greek. Visit my webpage at http://www.crosswinds.net/~spyros1973/ to find out some of my other programs....	");
//	   scrolly.x=SCRW;
//	   scrolly.y=SCRH-10;
//	   scrolly.delay=1;
//	   scrolly.w=80;
//	   *scrolly.wr='\0';
//	   scrolly.pos=0;
//	   scrolly.ln=strlen(scrolly.s);
	//scrolly.bmp=create_bitmap(text_length(font,scrolly.s),10);
	//clear_to_color(scrolly.bmp,makecol(255,0,255));
	//outlinetext(scrolly.bmp,font,scrolly.s,0,0,makecol(200,200,200),makecol(0,0,0));
	mnuchoice=-1;
	for (i=0; i<6; i++) {
		menuitem[i].mouseon=0;
		menuitem[i].curcol=menuitem[i].col1;
	}

	if (firstinit==0) {
		mnutxt[0]="human";
		mnutxt[1]="10MHz cpu";
		mnutxt[2]="200MHz cpu";
		mnutxt[3]="2GHz cpu";
		mnutxt[4]="red first";
		mnutxt[5]="yellow first";
		mnutxt[6]="random first";
		mnutxt[7]="play!";
		mnutxt[8]="exit";
		mnutxt[9]="classical";
		mnutxt[10]="blues";
		mnutxt[11]="samba";
		mnutxt[12]="no music";
		menuitem[0].first=0;
		menuitem[0].opts=3;
		menuitem[0].curopt=0;
		menuitem[0].col1=makecol(200,5,5);
		menuitem[0].col2=makecol(255,50,50);
		menuitem[1].first=0;
		menuitem[1].opts=3;
		menuitem[1].curopt=1;
		menuitem[1].col1=makecol(180,180,10);
		menuitem[1].col2=makecol(255,255,50);
		menuitem[2].first=4;
		menuitem[2].opts=2;
		menuitem[2].curopt=0;
		menuitem[2].col1=makecol(30,20,170);
		menuitem[2].col2=makecol(50,50,255);
		menuitem[3].first=9;
		menuitem[3].opts=3;
		menuitem[3].curopt=0;
		menuitem[3].col1=makecol(10,200,20);
		menuitem[3].col2=makecol(50,255,50);
		menuitem[4].first=7;
		menuitem[4].opts=0;
		menuitem[4].curopt=0;
		menuitem[4].col1=makecol(50,50,90);
		menuitem[4].col2=makecol(120,120,220);
		menuitem[5].first=8;
		menuitem[5].opts=0;
		menuitem[5].curopt=0;
		menuitem[5].col1=makecol(75,125,135);
		menuitem[5].col2=makecol(105,165,165);
		set_trans_blender(0,0,0,128);
		for (i=0; i<6; i++) {
			menuitem[i].y=156+54*i;
			menuitem[i].mouseon=0;
			menuitem[i].curcol=menuitem[i].col1;
		}
	}
	firstinit=1;
}

void input()
{
	static int pressed;
	int tmpmus; // holds the current music state
	tmpmus=menuitem[3].curopt;
	if ((key[KEY_UP] || key[KEY_DOWN]) && (mnuchoice==-1)) {
		mnuchoice=0;
		position_mouse(SCRW/2,menuitem[0].y+8);
	}
	if ( (!key[KEY_UP]) && (!key[KEY_DOWN]) && (!key[KEY_SPACE]) && (!key[KEY_ENTER]) && (!(mouse_b &1)) ) pressed=0; // to avoid fast key repeats
	if ((key[KEY_DOWN]) && (mnuchoice<5) && (mnuchoice!=-1) && (pressed==0)) {
		mnuchoice++;
		position_mouse(SCRW/2,menuitem[mnuchoice].y+8);
		pressed=1;
	}
	if ((key[KEY_UP]) && (mnuchoice>0) && (mnuchoice!=-1) && (pressed==0)) {
		mnuchoice--;
		position_mouse(SCRW/2,menuitem[mnuchoice].y+8);
		pressed=1;
	}
	if ((mnuchoice!=-1) && ( CMDKEY ) && (pressed==0)) {
		menuitem[mnuchoice].curopt++;
		if (menuitem[mnuchoice].curopt>menuitem[mnuchoice].opts) menuitem[mnuchoice].curopt=0;
		pressed=1;
	}
	if ((mnuchoice>3) && ( CMDKEY )) {
		menuover=mnuchoice-3;
		pressed=0;
	}

	if (key[KEY_ESC]) menuover=2;
	if ((menuitem[3].curopt!=tmpmus) && (!nomusic)) {
		if (menuitem[3].curopt==0) play_midi(data[_music1].dat,1);
		if (menuitem[3].curopt==1) play_midi(data[_music2].dat,1);
		if (menuitem[3].curopt==2) play_midi(data[_music3].dat,1);
		if (menuitem[3].curopt==3) play_midi(NULL,0);
	}
}

void processmenu()
{
	int i,tmp;
	int colexist = 0; // if mouse pointer is over a menu option
	for (i=0; i<6; i++) {
		tmp=(SCRW/2)-(text_length(data[_aafont].dat, mnutxt[menuitem[i].first+menuitem[i].curopt] )/2);
		menuitem[i].x=tmp;
		menuitem[i].w=text_length(data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt] );
		menuitem[i].h=48;
		tmp=detectcollision(mouse_x,mouse_y,1,1,menuitem[i].x,menuitem[i].y,menuitem[i].w,menuitem[i].h);
		if (tmp==1) colexist=1;
		if ((tmp==1) && (menuitem[i].mouseon==0)) {
			menuitem[i].mouseon=1;
			menuitem[i].curcol=menuitem[i].col2;
			mnuchoice=i;
			if (!nosound) play_sample(data[_cmd].dat,128,0,1000,0); // play a tick sound
		}
		if (tmp==0) {
			menuitem[i].mouseon=0;
			menuitem[i].curcol=menuitem[i].col1;
		}
	}
	if (colexist==0) mnuchoice=-1;
//	   scrolly.delay++;
//	   if (scrolly.delay==4) {
//		   scrolly.delay=0;
//		   scrolly.pos++;
//		   for (i=0; i<scrolly.w; i++) {
//			   if (scrolly.pos+i<scrolly.ln-1) scrolly.wr[i]=scrolly.s[i+scrolly.pos];
//			   else scrolly.wr[i]=' ';
//		   }
//		   scrolly.wr[i]='\0';
//		   if (scrolly.pos>scrolly.ln) scrolly.pos=0;
//	   }

}

void displaymenu(resx,resy)
{
	int i,sx,sy;
	blit(data[_titlescreen].dat,buffer,0,0,0,0,SCRW,SCRH);
	sx=(mouse_x-(SCRW/2))/24;
	for (i=0; i<6; i++) {
		sy=(mouse_y-menuitem[i].y)/30;
		textout(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x-sx,menuitem[i].y-sy,makecol(0,0,0));
//		   textout(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x-1,menuitem[i].y-1,makecol(20,20,0));
//		   textout(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x-1,menuitem[i].y+1,makecol(20,20,0));
//		   textout(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x+1,menuitem[i].y-1,makecol(20,20,0));
//		   textout(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x+1,menuitem[i].y+1,makecol(20,20,0));
//		   textout(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x,menuitem[i].y,menuitem[i].curcol);
		outlinetext(buffer,data[_aafont].dat,mnutxt[menuitem[i].first+menuitem[i].curopt],menuitem[i].x,menuitem[i].y,menuitem[i].curcol,makecol(20,20,0));
	}
	//masked_blit(scrolly.bmp,buffer,0,0,scrolly.x,scrolly.y,scrolly.bmp->w,10);
	//textout(buffer,font,scrolly.wr,-scrolly.delay*2,scrolly.y,makecol(255,255,255));
	//outlinetext(buffer,font,scrolly.wr,-scrolly.delay*2,scrolly.y,makecol(255,255,255),makecol(0,0,0));
	//textprintf(buffer,font,10,10,makecol(255,255,255),"mnuchoice = %d",mnuchoice);
	//textprintf(buffer,font,10,20,makecol(255,255,255),"mid state = %d",menuitem[3].curopt);
	//textprintf(buffer,font,10,30,makecol(255,255,255),"choice 3 x y = %d %d",menuitem[3].x,menuitem[3].y);
	//textprintf(buffer,font,10,40,makecol(255,255,255),"Mod playing = %d",is_mod_playing());
	outlinetext(buffer,font,"v1.8",608,0,makecol(200,200,200),makecol(10,10,10));
	outlinetext(buffer,font,"by Spyros Paraschis",0,472,makecol(200,200,200),makecol(10,10,10));
	//displayparticles();
	draw_sprite(buffer,data[_pointer].dat,mouse_x,mouse_y);
	vsync();
	if (resx==640) blit(buffer,screen,0,0,0,0,SCRW,SCRH);
	else stretch_blit(buffer,screen,0,0,SCRW,SCRH,0,0,resx,resy);
	clear(buffer);
}


